//
//  Enumeration_Type.h
//  NemoSDK
//
//  Created by XYLink on 16/9/30.
//  Copyright © 2016年 XYLink. All rights reserved.
//

#ifndef Enumeration_Type_h
#define Enumeration_Type_h

/// 呼叫状态
typedef NS_ENUM(NSInteger, NemoCallState) {
    /// 已连接
    NemoCallState_Connected,
    /// 未连接
    NemoCallState_DisConnected,
    /// 正在连接
    NemoCallState_Connecting,
};

/// 呼叫的终端类型
typedef NS_ENUM(NSUInteger, NemoCallType) {
    /// 点对点
    NemoCallType_PIP,
    /// 会议室
    NemoCallType_Conference,
    /// 硬件
    NemoCallType_Device,
    /// 云呼叫中心
    NemoCallType_CCC,
    /// 直播
    NemoCallType_LiveRoom,
};

/// 通话模式
typedef NS_ENUM(NSInteger, NemoCallMode) {
    /// 音视频
    NemoCallMode_AudioVideo,
    /// 音频
    NemoCallMode_Audio,
};

/// 会控请求
typedef NS_ENUM(NSUInteger, NemoMediaQuery) {
    /// 关闭麦克风
    NemoMediaQuery_MuteMicrophone,
    /// 关闭摄像头
    NemoMediaQuery_MuteCamera,
};

/// 分享content类型
typedef NS_ENUM(NSInteger, NemoShareContentType) {
    /// 分享图片
    NemoShareContentType_Image,
    /// 分享屏幕
    NemoShareContentType_Screen,
};

/// 分享content状态
typedef NS_ENUM(NSInteger, NemoShareContentState) {
    /// 闲置，停止发送
    NemoShareContentState_Idle,
    /// 开始发送
    NemoShareContentState_Acquiring,
    /// 发送中
    NemoShareContentState_Sending,
    /// 不支持
    NemoShareContentState_Unsupported,
    /// 带宽不足
    NemoShareContentState_NoBandwidth,
    /// 未知
    NemoShareContentState_Unknown,
};

/// 视频流状态
typedef NS_ENUM(NSInteger, NemoStreamState) {
    /// 闲置
    NemoStreamState_Idle,
    /// 监听
    NemoStreamState_Observing,
    /// 视频关闭
    NemoStreamState_Mute,
    /// 请求中
    NemoStreamState_Requesting,
    /// 带宽不足
    NemoStreamState_NoBandwidth,
    /// 无解码器
    NemoStreamState_NoDecoder,
    /// 正常接收
    NemoStreamState_Received,
    /// 电话
    NemoStreamState_Telephone,
    /// 只有音频
    NemoStreamState_AudioOnly,
    /// 只收到音频
    NemoStreamState_ReceivedAudioOnly,
};

/// 会控状态
typedef NS_ENUM(NSInteger, NemoConferenceManagerManagementType) {
    /// 无操作
    NemoConferenceManagerManagementType_Default,
    /// 静音
    NemoConferenceManagerManagementType_Mute,
    /// 强制静音
    NemoConferenceManagerManagementType_MuteMandatory,
    /// 取消静音
    NemoConferenceManagerManagementType_Unmute,
    /// 暂时取消静音
    NemoConferenceManagerManagementType_UnmuteTemporary,
};

/// log级别
typedef NS_ENUM(NSInteger, NemoLogLevel) {
    /// 错误信息
    NemoLogLevel_Error,
    /// 警告信息
    NemoLogLevel_Warn,
    /// 媒体信息
    NemoLogLevel_Info,
    /// 调试信息
    NemoLogLevel_Debug,
};

/// 远端类型
typedef NS_ENUM(NSInteger, NemoDeviceType) {
    /// 未知
    NemoDeviceType_Unknown,
    /// APP
    NemoDeviceType_Contact = 1,
    /// 小鱼
    NemoDeviceType_Device,
    /// 云会议室
    NemoDeviceType_MeetingRoom,
    /// 电话
    NemoDeviceType_PSTN,
    /// 电脑
    NemoDeviceType_Desktop = 5,
    /// 323
    NemoDeviceType_H323,
    /// 大鱼
    NemoDeviceType_Bruce,
    /// tvbox
    NemoDeviceType_Tvbox,
    /// 监控
    NemoDeviceType_Shuttle,
};

/// 全量roster类型
typedef NS_ENUM(NSUInteger, NemoBulkRosterType) {
    /// 全量数据
    NemoBulkRosterType_Full,
    /// 增量数据
    NemoBulkRosterType_Increment,
};

/// 音视频关闭原因
typedef NS_ENUM(NSInteger, NemoMuteReason) {
    /// 用户关闭视频
    NemoMuteReason_User,
    /// 带宽限制
    NemoMuteReason_BWLimit,
    /// 没有输入
    NemoMuteReason_NoInput,
    /// 会控关闭
    NemoMuteReason_ConfMgmt,
    /// 硬件检测关闭
    NemoMuteReason_DeviceDetection,
    /// 电话关闭
    NemoMuteReason_PhoneCall,
};

/// 视频状态
typedef NS_ENUM(NSInteger, NemoVideoState) {
    /// 正常状态，ui不需要显示
    NemoVideoState_Normal,
    /// 本地网络不稳定
    NemoVideoState_LowAsLocalBw,
    /// 系统忙，视频质量降低
    NemoVideoState_LowAsLocalHardware,
    /// 对方网络不稳定
    NemoVideoState_LowAsRemote,
    /// 网络不稳定，请稍候
    NemoVideoState_NetworkError,
    /// WiFi信号不稳定
    NemoVideoState_LocalWifiIssue,
};

/// 本地视频方向
typedef NS_ENUM(NSUInteger, NemoVideoOrientation) {
    /// 跟随系统
    NemoVideoOrientation_Auto,
    /// 竖屏
    NemoVideoOrientation_Portrait,
    /// 横屏 home键朝左
    NemoVideoOrientation_LandscapeLeft,
    /// 横屏 home键朝右
    NemoVideoOrientation_LandscapeRight,
};

/// 等候室状态
typedef NS_ENUM(NSUInteger, NemoWaitingRoomState) {
    /// 未知
    NemoWaitingRoomState_Unknown,
    /// 等待主持人批准
    NemoWaitingRoomState_WaitApprove,
    /// 等待主持人入会
    NemoWaitingRoomState_WaitHostJoin,
};

/// 字幕显示位置
typedef NS_ENUM(NSInteger, NemoCaptionLocation) {
    /// 上部
    NemoCaptionLocationTop,
    /// 中部
    NemoCaptionLocationMiddle,
    /// 下部
    NemoCaptionLocationBottom,
};

/// 字体大小
typedef NS_ENUM(NSInteger,NemoCaptionFontSize) {
    /// 小
    NemoCaptionFontSizeSmall,
    /// 中
    NemoCaptionFontSizeMiddle,
    /// 大
    NemoCaptionFontSizeBig,
};

/// 请流布局优先级
typedef NS_ENUM(NSInteger, NemoLayoutPriority) {
    /// 较高
    NemoLayoutPriority_High     = 100,
    /// 一般
    NemoLayoutPriority_Normal   = 200,
    /// 较低
    NemoLayoutPriority_Low      = 300,
};

/// 请流视频质量
typedef NS_ENUM(NSInteger, NemoVideoQuality) {
    /// 较高
    NemoVideoQuality_High     = 100,
    /// 一般
    NemoVideoQuality_Normal   = 200,
    /// 较低
    NemoVideoQuality_Base     = 300,
};

/// 请流分辨率
typedef NS_ENUM(NSInteger, NemoVideoResolution) {
    /// 320 x 180
    NemoVideoResolution_180P      = 100,
    /// 640 x 360
    NemoVideoResolution_360P      = 200,
    /// 1280 x 720
    NemoVideoResolution_720P      = 300,
    /// 1080 x 1920
    NemoVideoResolution_1080P     = 400,
};

/// 白板远端状态
typedef NS_ENUM(NSInteger, NemoWhiteboardRemoteState) {
    /// 未知
    NemoWhiteboardRemoteState_Unknown,
    /// 开启
    NemoWhiteboardRemoteState_Start,
    /// 关闭
    NemoWhiteboardRemoteState_Stop,
    /// 错误
    NemoWhiteboardRemoteState_Error,
};

/// 白板操作
typedef NS_ENUM(NSInteger, NemoWhiteboardOperationState) {
    /// 设置画布
    NemoWhiteboardOperation_setCanvas,
    /// 画线
    NemoWhiteboardOperation_Draw,
    /// 清理
    NemoWhiteboardOperation_Clear,
    /// 所有线条
    NemoWhiteboardOperation_All,
    /// 撤销
    NemoWhiteboardOperation_Undo,
    /// 重做
    NemoWhiteboardOperation_Redo,
    /// 未知
    NemoWhiteboardOperation_Unkown,
};

/// 标注状态
typedef NS_ENUM(NSUInteger, NemoAnnotationStatus) {
    /// 未知
    NemoAnnotationStatus_Unknown,
    /// 开启
    NemoAnnotationStatus_Start,
    /// 关闭
    NemoAnnotationStatus_Stop,
    /// 错误
    NemoAnnotationStatus_Error,
};

/// 标注操作
typedef NS_ENUM(NSUInteger, NemoAnnotationOperation) {
    /// 画线
    NemoAnnotationOperation_DrawLine,
    /// 清理
    NemoAnnotationOperation_Clear,
    /// 获取
    NemoAnnotationOperation_GetAllLine,
    /// 撤销
    NemoAnnotationOperation_Undo,
    /// 重做
    NemoAnnotationOperation_Redo,
    /// 获取状态
    NemoAnnotationOperation_Status,
    /// 获取信息
    NemoAnnotationOperation_Info,
    /// 画线反馈
    NemoAnnotationOperation_Feedback,
    /// 无操作
    NemoAnnotationOperation_None,
};

/// 录制状态
typedef NS_ENUM(NSUInteger, NemoRecordingState) {
    /// 录制开始
    NemoRecordingState_Start,
    /// 录制暂停
    NemoRecordingState_Pause,
    /// 录制继续
    NemoRecordingState_Active,
    /// 录制结束
    NemoRecordingState_Stop,
};


/// 设置视频输出分辨率
typedef NS_ENUM(NSInteger, NemoVideoDimension) {
    /// 320 x 180
    NemoVideoDimension_180P,
    /// 640 x 360
    NemoVideoDimension_360P,
    /// 1280 x 720
    NemoVideoDimension_720P,
};

/// 网络测试结果
typedef NS_ENUM(NSInteger, NemoNetworkTestCode) {
    /// 正常
    NemoNetworkTestCode_NoError,
    /// 终止
    NemoNetworkTestCode_Expired,
    /// 强制结束
    NemoNetworkTestCode_Killed,
    /// tcp连接失败
    NemoNetworkTestCode_CreateTCPSocketFail,
    /// udp连接失败
    NemoNetworkTestCode_CreateUDPSocketFail,
    /// 无网络连接
    NemoNetworkTestCode_LostConnection,
    /// 未找到服务器
    NemoNetworkTestCode_NotFoundServer,
};

/// 美颜
typedef NS_ENUM(NSUInteger, NemoBeautyEffectType) {
    /// 无美颜
    NemoBeautyEffectType_None,
    /// 美白
    NemoBeautyEffectType_Whitening,
    /// 磨皮
    NemoBeautyEffectType_Buffing,
    /// 红润
    NemoBeautyEffectType_Blush,
};

/// 滤镜
typedef NS_ENUM(NSUInteger, NemoVideoFilterType) {
    /// 无滤镜
    NemoVideoFilterType_None,
    /// 简洁
    NemoVideoFilterType_Concise,
    /// 自然
    NemoVideoFilterType_Natural,
    /// 精致
    NemoVideoFilterType_Exquisite,
    /// 宁静
    NemoVideoFilterType_Peaceful,
    /// 柔和
    NemoVideoFilterType_Soft,
    /// 轻奢
    NemoVideoFilterType_LightLuxury,
    /// 青春
    NemoVideoFilterType_Youth,
    /// 雨后
    NemoVideoFilterType_Rain,
    /// 校园
    NemoVideoFilterType_Campus,
    /// 热情
    NemoVideoFilterType_Warmth,
    /// 清新
    NemoVideoFilterType_Refreshing,
    /// 银河
    NemoVideoFilterType_Galaxy,
    /// 清澈
    NemoVideoFilterType_Pure,
    /// 清晨
    NemoVideoFilterType_Dawn,
    /// 梦幻
    NemoVideoFilterType_Dream,
    /// 高光
    NemoVideoFilterType_HighLight,
    /// 典雅
    NemoVideoFilterType_Elegant,
    /// 怀旧
    NemoVideoFilterType_Nostalgia,
    /// 暗调
    NemoVideoFilterType_Dark,
    /// 老电影
    NemoVideoFilterType_Retro,
};

/// 虚拟背景配置
typedef NS_ENUM(NSInteger, NemoVirtualBackgroundMode) {
    /// 无背景
    NemoVirtualBackgroundMode_Close,
    /// 背景模糊
    NemoVirtualBackgroundMode_Blur,
    /// 图片选择
    NemoVirtualBackgroundMode_Image,
};

/// 会控互动状态
typedef NS_ENUM(NSUInteger, NemoInteractiveState) {
    /// 开始
    NemoInteractiveState_Start,
    /// 公布结果
    NemoInteractiveState_Announce,
    /// 关闭
    NemoInteractiveState_Close,
    /// 结束
    NemoInteractiveState_End,
};

/// FECC，控制硬件终端摄像头时使用
typedef NS_ENUM(NSInteger, NemoFECCOperation) {
    NemoFECCOperation_TurnLeft,
    NemoFECCOPeration_StepLeft,
    NemoFECCOperation_TurnRight,
    NemoFECCOPeration_StepRight,
    NemoFECCOperation_Stop,
    NemoTILT_CAMERA_TURN_UP,
    NemoTILT_CAMERA_STEP_UP,
    NemoTILT_CAMERA_TURN_DOWN,
    NemoTILT_CAMERA_STEP_DOWN,
    NemoTILT_CAMERA_TURN_STOP,
    NemoFECCOperation_ZoomIn,
    NemoFECCOperation_ZoomOut,
    NemoFECCOperation_STEP_ZOOM_IN,
    NemoFECCOperation_STEP_ZOOM_OUT,
    NemoFECCOperation_ZOOM_TURN_STOP,
    NemoFECCOperation_MOVE_LEFT_TURN,
    NemoFECCOperation_MOVE_LEFT_STEP,
    NemoFECCOperation_MOVE_RIGHT_TURN,
    NemoFECCOperation_MOVE_RIGHT_STEP,
    NemoFECCOperation_MOVE_UP_TURN,
    NemoFECCOperation_MOVE_UP_STEP,
    NemoFECCOperation_MOVE_DOWN_TURN,
    NemoFECCOperation_MOVE_DOWN_STEP,
    NemoFECCOperation_MOVE_STOP
};

#endif /* Enumeration_Type_h */
