//
//  XYRTCEngine+AiFace.h
//  XYRTCEngine
//
//  Created by 高超 on 2022/2/24.
//

#import "XYRTCEngine.h"

NS_ASSUME_NONNULL_BEGIN

@interface XYRTCEngine (AiFace)

/// 人脸识别开关
/// @param enable YES：开启 NO：关闭
- (void)enableFaceRecognize:(BOOL)enable;

/// 电子铭牌开关（使用电子铭牌必须开启人脸识别）
/// @param enable YES：开启 NO：关闭
- (void)enableElectronicBadge:(BOOL)enable;

/// 人脸识别和电子铭牌切换
/// @param type 类型  0：人脸识别 2：电子铭牌
/// @param state 设置状态 YES 显示 NO 隐藏
- (void)faceDetect:(int)type state:(BOOL)state;

/// 获取人脸信息
/// @param faceId 人脸id
/// @param completion 回调 
- (void)getFaceInfo:(long)faceId completion:(void (^)(BOOL success, id responseObject))completion;

/// 是否支持同传字幕
///
/// return YES 支持， NO 不支持
///
- (BOOL)isSupportAiCaption;

/// 同传字幕，设置语言
/// @param language 语言，传@"Chinese" 或者 @"English"
- (void)setSubtitleLanguage:(NSString *)language;

@end

NS_ASSUME_NONNULL_END
