//
//  XYRTCEngine+Beauty.h
//  XYRTCEngine
//
//  Created by 高超 on 2022/4/14.
//

#import "XYRTCEngine.h"

NS_ASSUME_NONNULL_BEGIN

@interface XYRTCEngine (Beauty)

/// 设置本地视频预览视图，调用此方法会占用摄像头，设置完成后请务必调用finishSetVideoPreview释放资源
/// @param preview 预览视图
- (void)setVideoPreview:(UIView *)preview;

/// 设置完成，释放占用资源
- (void)finishSetVideoPreview;

/// 设置美颜
/// @param type 美颜类型
/// @param level 强度等级 0~100
- (void)setVideoBeautyEffect:(XYBeautyEffectType)type level:(NSInteger)level;

/// 设置滤镜
/// @param type 滤镜类型
/// @param level 强度等级 0~100
- (void)setVideoFilterEffect:(XYVideoFilterType)type level:(NSInteger)level;

/// 设置虚拟背景样式，支持iOS12及以上系统
/// @param mode 虚拟背景模式
/// XYVirtualBackgroundModeClose 无背景
/// XYVirtualBackgroundModeBlur 背景模糊
/// XYVirtualBackgroundModeImage 图片选择 image 必传
/// @param image JPG图片的绝对路径
/// @param width 图片宽度 无背景、背景模糊 0
/// @param height 图片高度 无背景、背景模糊 0
- (void)setVirtualBackgroudMode:(XYVirtualBackgroundMode)mode
                          image:(UIImage * _Nullable)image
                     imageWidth:(NSInteger)width
                    imageHeight:(NSInteger)height;

@end

NS_ASSUME_NONNULL_END
