//
//  XYRTCEngine+NetTool.h
//  XYRTCEngine
//
//  Created by 高超 on 2021/5/29.
//

#import "XYRTCEngine.h"

NS_ASSUME_NONNULL_BEGIN

@interface XYRTCEngine (NetTool)

/// 开始网络测试
/// @param completion 回调
- (void)startNetworkTestCompletion:(void (^)(XYNetTestResult *_Nullable result, XYNetworkTestCode testError))completion;

/// 停止网络测试
- (void)stopNetworkTest;

/// 线路配置
/// @param complete 回调
- (void)getSitePaths:(void (^)(XYSitePath *sitePath))complete;

/// 保存线路配置
/// @param info 线路信息
/// @param complete 回调
- (void)configSitePath:(XYSitePathInfo *)info
              complete:(void (^)(BOOL isSuccess))complete;

/// 删除线路配置
/// @param info 线路信息
/// @param complete 回调
- (void)deleteSitePath:(XYSitePathInfo *)info
              complete:(void (^)(BOOL isSuccess))complete;

/// 测试代理服务器
/// @param ip 地址
/// @param port 端口
/// @param userName 用户名
/// @param password 密码
- (void)validateSocksProxy:(NSString *)ip
                      port:(NSString *)port
                  userName:(NSString *)userName
                  password:(NSString *)password;

/// 设置代理服务器
/// @param ip 地址
/// @param port 端口
/// @param userName 用户名
/// @param password 密码
- (void)setSocksProxy:(NSString *)ip
                 port:(NSString *)port
             userName:(NSString *)userName
             password:(NSString *)password;

@end

NS_ASSUME_NONNULL_END
