//
//  XYRTCEngine+Record.h
//  API
//
//  Created by 高超 on 2021/3/9.
//

#import "XYRTCEngine.h"

NS_ASSUME_NONNULL_BEGIN

@interface XYRTCEngine (Record)

/// 检查录制权限
/// @param meetingNumber 会议号
/// @param completion 回调 (isRecordable 是否可录制 recordingUrl 录制地址 error 错误信息)
- (void)checkPermissionWithMeetingNumber:(NSString* )meetingNumber
                              completion:(void (^)(BOOL isRecordable, NSString *recordingUrl, NSError *error))completion;

/// 检查录制空间
/// @param recordingUrl 录制地址
/// @param completion 回调 (isStorage  是否有存储空间 error  错误信息)
- (void)checkSorageSpaceWithRecordingUrl:(NSString *)recordingUrl
                              completion:(void (^)(BOOL isStorage, NSError *error))completion;

/// 开始录制
/// @param recordingUrl 录制地址
- (void)startRecording:(NSString *)recordingUrl;

/// 停止录制
/// @param recordingUrl 录制地址
- (void)stopRecording:(NSString *)recordingUrl;

@end

NS_ASSUME_NONNULL_END
