//
//  XYRTCEngineExtension.h
//  XYRTCEngineExtension
//
//  Created by 高超 on 2021/8/31.
//

#import <Foundation/Foundation.h>
#import <CoreMedia/CoreMedia.h>
#import <ReplayKit/ReplayKit.h>

NS_ASSUME_NONNULL_BEGIN

@interface XYRTCEngineExtension : NSObject

/// 获取单例
+ (instancetype)sharedInstance;

/// 扩展进程开启时初始化配置
///
/// 在”- (void)broadcastStartedWithSetupInfo:(NSDictionary<NSString *,NSObject *> *)setupInfo“方法中调用
///
/// @param handler 回调
/// @param message 进程结束时系统Alert提示内容，传空时不提示
- (void)extensionStartSampleHandlerWithHandler:(RPBroadcastSampleHandler *)handler message:(NSString *_Nullable)message;

/// 扩展进程结束
///
/// 在 ”- (void)broadcastFinished“ 方法中调用
///
- (void)extensionFinished;

/// 发送数据
///
/// 在”- (void)processSampleBuffer:(CMSampleBufferRef)sampleBuffer withType:(RPSampleBufferType)sampleBufferType“方法中调用
///
/// @param sampleBuffer 数据帧
/// @param sampleBufferType 数据类型
- (void)extensionProcessSampleBuffer:(CMSampleBufferRef)sampleBuffer
                            withType:(RPSampleBufferType)sampleBufferType;

@end

NS_ASSUME_NONNULL_END
