//
//  XYTableViewSectionModel.h
//  xylink_app
//
//  Created by chengronggang on 2021/1/21.
//  Copyright © 2021 ainemo. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "XYTableViewCellModel.h"

typedef UIView * (^XYViewRenderBlock)(NSInteger section, UITableView *tableView);

/** Table view's section model */
@interface XYTableViewSectionModel : NSObject

@property (nonatomic, strong) NSMutableArray<XYTableViewCellModel *> *cellModelArray;
@property (nonatomic, strong) NSString *headerTitle;  // optional
@property (nonatomic, strong) NSString *footerTitle;  // optional
// if not specified, will use UITableViewAutomaticDimension as default value
@property (nonatomic, assign) CGFloat headerHeight;  // optional
@property (nonatomic, assign) CGFloat footerHeight;  // optional

// view render blocks' priority is higher then view property.
// e.g. if headerViewRenderBlock and headerView are both provided, headerViewRenderBlock will be
// used
@property (nonatomic, copy) XYViewRenderBlock headerViewRenderBlock;  // block to render header
// view
@property (nonatomic, copy) XYViewRenderBlock footerViewRenderBlock;  // block to render footer
// view
@property (nonatomic, strong) UIView *headerView;  // section header view
@property (nonatomic, strong) UIView *footerView;  // section footer view

@end
